#ifndef ANALYSIS_EX_H
#define ANALYSIS_EX_H


#include "TObject.h"
#include "TClonesArray.h"
#include "TFile.h"
#include "TH1D.h"
#include "TH2D.h"
#include "TTree.h"
#include "TProfile.h"

#include <string>

#include "Utilities/ExRootAnalysis/interface/ExRootTreeReader.h"
#include "Utilities/ExRootAnalysis/interface/ExRootTreeWriter.h"
#include "Utilities/ExRootAnalysis/interface/ExRootTreeBranch.h"
#include "Utilities/ExRootAnalysis/interface/TSimpleArray.h"
#include "Utilities/ExRootAnalysis/interface/BlockClasses.h"

using namespace std;

class Analysis_Ex 
{
public :

  Analysis_Ex(string CardWithCuts,string LogName);  
  ~Analysis_Ex();
  
  void Run(ExRootTreeReader *treeReaderGen, ExRootTreeReader *treeReaderRec, ExRootTreeReader *treeReaderTrig, ExRootTreeWriter *treeWriter);//Analyze de l'event
  void WriteOutput(string LogName);

  // histograms
  TH1D *debug;

  TH1D *btag;


  TH1D *jet_pt;
  TH1D *jet_eta;
  TH1D *jet_mass;
  TH1D *jet_hem;

  TH1D *jet_pt_b;
  TH1D *jet_eta_b;
  TH1D *jet_mass_b;

  TH1D *top_eta;
  TH1D *top_pt;

  double minPTall;
  double maxEta;
  

private :

  int total, cut_trig,cut_1,cut_2;

  //******** Thresholds definition ***********
  float INV_MASS_LL;
  float PT_ELEC,PT_MUON;
  int MaxEvents;
  bool xdebug;
  int type;


  TSimpleArray<TRootElectron> SubArrayEl(const TClonesArray *ELEC,float pt);
  TSimpleArray<TRootMuon> SubArrayMu(const TClonesArray *MUON,float pt);

};

//------------------------------------------------------------------------------

class TRootInvm: public TObject
{
public:

Float_t M;

  ClassDef(TRootInvm, 1)
};


#endif
